package net.toomuchram.backendDummy.managers

import org.jetbrains.exposed.sql.*
import org.jetbrains.exposed.sql.transactions.transaction

class TeamsManager(
    private val userManager: UserManager
) {

    //Team Categories are essentially a team group
    // Example: "Loopgroepen"
    /**
     * Creates a new team category
     * @param categoryName [String] The name for the new team category
     * @throws Exceptions.AlreadyExistsException if a team category which such a name already exists
     */
    fun createTeamCategory(categoryName: String, excursionId: Int) {
        transaction {
            if (Tables.TeamCategories.select { Tables.TeamCategories.name eq categoryName and (Tables.TeamCategories.excursionId eq excursionId) }.count() > 0) {
                // Team category already exists
                throw Exceptions.AlreadyExistsException("Team category already exists")
            }
            //Team category check passed, insert the new team category
            //id will be automatically assigned, cuz IntIdTable
            Tables.TeamCategories.insert {
                it[name] = categoryName
                it[Tables.TeamCategories.excursionId] = EntityIDConverter.getExcursionEntityID(excursionId)
            }
        }
    }

    /**
     * Removes a team category if it exists
     * Also removes all child teams
     * @param categoryId The ID of the category; this ID is auto-generated by MariaDB/mySQL
     */
    fun removeTeamCategory(categoryId: Int, excursionId: Int) {
        transaction {
            Tables.TeamCategories.deleteWhere {
                (Tables.TeamCategories.id eq categoryId) and
                        (Tables.TeamCategories.excursionId eq excursionId)
            }
        }
    }

    fun createTeam(teamName: String, categoryId: Int, excursionId: Int) {
        transaction {
            //same here, check if a team with the same name doesn't already exist
            if ((Tables.Teams innerJoin Tables.TeamCategories).select {
                    Tables.Teams.name eq teamName and
                            (Tables.Teams.category eq categoryId) and
                            (Tables.Teams.category eq Tables.TeamCategories.id) and
                            (Tables.TeamCategories.excursionId eq excursionId)
            }.count() > 0) {
                throw Exceptions.AlreadyExistsException("Team already exists")
            }

            val categoryEntityID = EntityIDConverter.getTeamCategoryEntityID(categoryId)

            val categoryExcursionId = Tables.TeamCategories.select {
                Tables.TeamCategories.id eq categoryId
            }.elementAt(0)[Tables.TeamCategories.excursionId].value
            if (categoryExcursionId != excursionId) {
                throw Exceptions.NoSuchTeamCategoryException("Unauthorised")
            }

            Tables.Teams.insert {
                it[name] = teamName
                it[category] = categoryEntityID
            }
        }
    }

    /**
     * Removes a team if it exists
     * @param teamId The team's ID, auto-generated by mySQL/MariaDB
     */
    fun removeTeam(teamId: Int, excursionId: Int) {
        transaction {
            val teams = (Tables.Teams innerJoin Tables.TeamCategories).select {
                (Tables.TeamCategories.excursionId eq excursionId) and
                        (Tables.Teams.category eq Tables.TeamCategories.id)
            }

            if (teams.empty()) return@transaction

            Tables.Teams.deleteWhere {
                (Tables.Teams.id eq teamId)
            }
        }
    }

    /**
     * Add a new user to a team
     * @param userId The ID of the user. The ID should already be checked (if such a user exists)
     * @param teamId The ID of the team the user should belong to
     */
    fun addUserToTeam(userId: Int, teamId: Int) {
        val userExcursion = userManager.getExcursion(userId)
        val teamExcursion = getExcursion(teamId)
        if (userExcursion != teamExcursion) {
            throw Exceptions.NoSuchTeamException("Unauthorised")
        }

        if (!isUserInTeam(userId, teamId)) {
            val userEntityID = EntityIDConverter.getUserEntityID(userId)
            val teamEntityID = EntityIDConverter.getTeamEntityID(teamId)

            // Update the current team members value
            transaction {
                Tables.TeamMembers.insert {
                    it[Tables.TeamMembers.userId] = userEntityID
                    it[Tables.TeamMembers.teamId] = teamEntityID
                }
            }
        }

    }

    /**
     * Converts the JSON array from getTeamMembersJSONArray to a Kotlin List
     * @param teamId the ID of the team
     * @return A list containing the user IDs of the team members
     * Probably throws a NoSuchTeamException if the team doesn't exist
     */
    fun getTeamMembers(teamId: Int): List<Int> {
        return transaction {
            val teamMembersList = mutableListOf<Int>()
            val teamMembers = (Tables.Teams innerJoin Tables.TeamMembers)
                .slice(Tables.TeamMembers.userId)
                .select { (Tables.Teams.id eq teamId) and (Tables.Teams.id eq Tables.TeamMembers.teamId) }
            teamMembers.map { row ->
                teamMembersList.add(row[Tables.TeamMembers.userId].value)
            }
            return@transaction teamMembersList
        }
    }

    /**
     * Checks if a user is in a team
     * @param userId the ID of the user
     * @param teamId the ID of the team
     * Probably throws a NoSuchTeamException if the team doesn't exist
     */
    fun isUserInTeam(userId: Int, teamId: Int): Boolean {
        return transaction {
            return@transaction !(Tables.TeamMembers
                .slice(Tables.TeamMembers.userId)
                .select { (Tables.TeamMembers.teamId eq teamId) and (Tables.TeamMembers.userId eq userId) }
                .empty())
        }
    }

    /**
     * Removes the user from a team if the user is in that team
     * @param userId the ID of the user, as found in the user database
     * @param teamId the ID of the team
     */
    fun removeUserFromTeam(userId: Int, teamId: Int, excursionId: Int) {
        val userExcursion = userManager.getExcursion(userId)
        if (userExcursion != excursionId) {
            throw Exceptions.NoSuchTeamException("Unauthorised")
        }
        transaction {
            Tables.TeamMembers.deleteWhere {
                (Tables.TeamMembers.teamId eq teamId) and (Tables.TeamMembers.userId eq userId)
            }
        }
    }

    /**
     * List all category IDs and names
     * @return A list of pair containing the ID and the name
     */
    fun listTeamCategories(excursionId: Int, categoryId: Int? = null): List<Pair<Int, String>> {
        val teams = mutableListOf<Pair<Int, String>>()
        transaction {
            val query = if (categoryId == null) {
                Tables.TeamCategories.select { Tables.TeamCategories.excursionId eq excursionId }
            } else {
                Tables.TeamCategories.select {
                    Tables.TeamCategories.excursionId eq excursionId and
                            (Tables.TeamCategories.id eq categoryId)
                }
            }
            query.forEach {
                teams.add(
                    Pair(it[Tables.TeamCategories.id].value, it[Tables.TeamCategories.name])
                )
            }
        }
        return teams
    }

    /**
     * List all team IDs and names
     * @return A list of Teams containing the ID, the name and the category IDs
     */
    fun listTeams(excursionId: Int, categoryId: Int? = null): List<Team> {
        val teams = mutableListOf<Team>()
        transaction {
            val query = if (categoryId == null) {
                (Tables.Teams innerJoin Tables.TeamCategories).select {
                    Tables.Teams.category eq Tables.TeamCategories.id and
                            (Tables.TeamCategories.excursionId eq excursionId)
                }
            } else {
                (Tables.Teams innerJoin Tables.TeamCategories).select {
                    Tables.Teams.category eq Tables.TeamCategories.id and
                            (Tables.TeamCategories.excursionId eq excursionId) and
                            (Tables.Teams.category eq categoryId)
                }
            }
            query.forEach {
                teams.add(
                    Team(
                        it[Tables.Teams.id].value,
                        it[Tables.Teams.name],
                        it[Tables.Teams.category].value
                    )
                )
            }
        }
        return teams
    }

    fun getExcursion(teamId: Int): Int {
        return transaction {
            val teams = (Tables.Teams innerJoin Tables.TeamCategories)
                .slice(Tables.TeamCategories.excursionId)
                .select {
                    Tables.TeamCategories.id eq Tables.Teams.category and
                            (Tables.Teams.id eq teamId)
                }
            if (teams.empty()) {
                throw Exceptions.NoSuchTeamException("No such team found")
            }
            return@transaction teams.elementAt(0)[Tables.TeamCategories.excursionId].value
        }
    }

}